/******************************************************************
 * @file  receiver_bit_struct.h
 * @brief:    [file description] 
 * @author: HUOHUO
 * @Date 2024年10月30日
 * COPYRIGHT NOTICE: ITTC
 * Change_date         Owner         Change_content
 * 2024年10月30日        HUOHUO       create file

*****************************************************************/
#ifndef RECEIVER_BIT_STRUCT_H
#define RECEIVER_BIT_STRUCT_H
#include "type_define.h"

//GENERATE with Generate_receiver_bit_struct_h.m
//DO NOT MODIFY
//=======================================================================
//各微码或查找表偏移及指针定义
typedef struct receiver_bit_table_param_s
{
    //MPU CONFIG OFFSET

    // 存储微码参数表的ddr基地址和长度
    uint32_t    receiver_bit_config0_ddr_ptr;//receiver DM0微码配置文件ddr地址
    uint32_t    receiver_bit_config0_length;//receiver DM0微码配置文件ddr长度    
    uint32_t    receiver_bit_config1_ddr_ptr;//receiver DM1微码配置文件ddr地址
    uint32_t    receiver_bit_config1_length;//receiver DM1微码配置文件ddr长度
    uint32_t    receiver_bit_config2_ddr_ptr;//receiver DM2微码配置文件ddr地址
    uint32_t    receiver_bit_config2_length;//receiver DM2微码配置文件ddr地址
    uint32_t    receiver_bit_config3_ddr_ptr;//receiver DM3微码配置文件ddr地址
    uint32_t    receiver_bit_config3_length;//receiver DM3微码配置文件ddr地址

    //SPU查找表在SM中的偏移地址



    // SPU LUT SM基地址和长度


}receiver_bit_table_param_t;


//=======================================================================
#endif