/******************************************************************
 * @file  RECEIVER_SYMB_symb_macro.h
 * @brief:    [file description] 
 * @author: HUOHUO
 * @Date 2024年10月30日
 * COPYRIGHT NOTICE: ITTC
 * Change_date         Owner         Change_content
 * 2024年10月30日        HUOHUO       create file
*****************************************************************/
#ifndef RECEIVER_SYMB_MACRO_H
#define RECEIVER_SYMB_MACRO_H

//GENERATE with Generate_RECEIVER_SYMB_symb_macro_h.m
//DO NOT MODIFY
//=======================================================================
//微码配置空间长度定义，单位为word(4Byte)
#define RECEIVER_SYMB_FreOffEst_CFG1_LENGTH (0x0090)
#define RECEIVER_SYMB_FreOffComp_CFG2_LENGTH (0x0040)
#define RECEIVER_SYMB_FreOffCordic_CFG3_LENGTH (0x0070)
#define RECEIVER_SYMB_ChannelEst_CFG4_LENGTH (0x0050)
#define RECEIVER_SYMB_Fft4096Int32_CFG5_LENGTH (0x0350)
#define RECEIVER_SYMB_EQ21Part1_CFG6_LENGTH (0x00E0)
#define RECEIVER_SYMB_EQ1Part2_CFG6_1_LENGTH (0x00C0)

#define RECEIVER_SYMB_IFFT4096_CFG7_LENGTH (0x0360)
#define RECEIVER_SYMB_IFFT4096_TURN_CFG7_LENGTH (0x0070)
#define RECEIVER_SYMB_IFFT4096_AddCP_CFG7_LENGTH (0x0130)
#define RECEIVER_SYMB_DeTransform2_CFG8_LENGTH (0x0060)
#define RECEIVER_SYMB_DeTransform4_CFG9_LENGTH (0x0080)

#define RECEIVER_SYMB_FREOFF_CFG_LENGTH (RECEIVER_SYMB_FreOffEst_CFG1_LENGTH + RECEIVER_SYMB_FreOffComp_CFG2_LENGTH + RECEIVER_SYMB_FreOffCordic_CFG3_LENGTH )
#define RECEIVER_SYMB_CHANNELEST_CFG_LENGTH (RECEIVER_SYMB_ChannelEst_CFG4_LENGTH)
#define RECEIVER_SYMB_CHANNELEQU_CFG_LENGTH (RECEIVER_SYMB_Fft4096Int32_CFG5_LENGTH + RECEIVER_SYMB_EQ21Part1_CFG6_LENGTH + RECEIVER_SYMB_EQ1Part2_CFG6_1_LENGTH + RECEIVER_SYMB_IFFT4096_CFG7_LENGTH + RECEIVER_SYMB_IFFT4096_TURN_CFG7_LENGTH + RECEIVER_SYMB_IFFT4096_AddCP_CFG7_LENGTH )

//SPU查找表各字段长度定义,单位为word(4Byte)


#define RECEIVER_SYMB_PilotOrig_LUT1_LENGTH (0x0420)
#define RECEIVER_SYMB_EqW4096_LUT2_LENGTH (0x2000)
#define RECEIVER_SYMB_EqFactor0_LUT3_LENGTH (0x0800)
#define RECEIVER_SYMB_EqFactor1_LUT4_LENGTH (0x0800)
#define RECEIVER_SYMB_EqFactor_LUT5_LENGTH (0x0078)
#define RECEIVER_SYMB_EqCpPhase_LUT6_LENGTH (0x0004)

//=======================================================================


#define COMPENSATED_DATA_DDR_PTR (RECEIVER_SYMB_OUT)
#define CHANNELEST_DATA_DDR_PTR  (RECEIVER_SYMB_OUT + 0x3c000)
#define CHANNELEQU_DATA_DDR_PTR (RECEIVER_SYMB_OUT + 0x3c000 + 0x8000)            //equ output
#define TRANSFORMER_DATA_DDR_PTR (RECEIVER_SYMB_OUT)


//SPU查找表各字段长度定义,单位为word(4Byte)

//=======================================================================
#endif
