/******************************************************************
 * @file  receiver_sync_struct.h
 * @brief:    [file description] 
 * @author: HUOHUO
 * @Date 2024年10月30日
 * COPYRIGHT NOTICE: ITTC
 * Change_date         Owner         Change_content
 * 2024年10月30日        HUOHUO       create file

*****************************************************************/
#ifndef RECEIVER_SYNC_STRUCT_H
#define RECEIVER_SYNC_STRUCT_H
#include "type_define.h"
#include "receiver_sync_vars.h"
#include "interface_rec_sync2_rec_symb.h"

//GENERATE with Generate_receiver_sync_struct_h.m
//DO NOT MODIFY
//=======================================================================
//各微码或查找表偏移及指针定义
typedef struct receiver_sync_table_param_s
{
    //MPU CONFIG OFFSET
    uint32_t    ConfigByteCopy_CFG1_Offset;
    uint32_t    ConfigSlidingCorrelation_CFG2_Offset;
    uint32_t    ConfigSlidingCorrelationSecond_CFG3_Offset;
    uint32_t    ConfigSyncVer_CFG4_Offset;
    // 存储微码参数表的ddr基地址和长度
    uint32_t    receiver_sync_config0_ddr_ptr;//receiver DM0微码配置文件ddr地址
    uint32_t    receiver_sync_config0_length;//receiver DM0微码配置文件ddr长度    
    uint32_t    receiver_sync_config1_ddr_ptr;//receiver DM1微码配置文件ddr地址
    uint32_t    receiver_sync_config1_length;//receiver DM1微码配置文件ddr长度
    uint32_t    receiver_sync_config2_ddr_ptr;//receiver DM2微码配置文件ddr地址
    uint32_t    receiver_sync_config2_length;//receiver DM2微码配置文件ddr地址
    uint32_t    receiver_sync_config3_ddr_ptr;//receiver DM3微码配置文件ddr地址
    uint32_t    receiver_sync_config3_length;//receiver DM3微码配置文件ddr地址

    //SPU查找表在SM中的偏移地址


    // SPU LUT SM基地址和长度


}receiver_sync_table_param_t;



typedef struct receiver_sync2first_sync_s
{
    uint16_t sfn;
    uint16_t slot;
    
}receiver_sync2first_sync_t;






typedef enum
{
    SYNC_IDLE=0,
    SYNC_FIRST_RUNING,
    SYNC_TRACKING
}receiver_sync_status_e;


typedef enum
{
    SYNC_OK=0,
    SYNC_FAIL
}receiver_sync_ret_e;

//=======================================================================
#endif